
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>LSTMs with chemistry &#8212; Battery SOH 2022 documentation</title>
    
  <link href="_static/css/theme.css" rel="stylesheet" />
  <link href="_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="_static/basic.css" />
    
  <link rel="preload" as="script" href="_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="index.html">
  <img src="_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                
<div class="tocsection onthispage pt-5 pb-3">
    <i class="fas fa-list"></i> On this page
</div>

<nav id="bd-toc-nav">
    <ul class="visible nav section-nav flex-column">
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#models">
   Models
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#dataset-classes">
   Dataset Classes
  </a>
 </li>
</ul>

</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <div class="section" id="lstms-with-chemistry">
<h1>LSTMs with chemistry<a class="headerlink" href="#lstms-with-chemistry" title="Permalink to this headline">¶</a></h1>
<p>This module (<code class="xref py py-mod docutils literal notranslate"><span class="pre">LSTM_chemistry</span></code>) contains the <code class="docutils literal notranslate"><span class="pre">'chemistry'</span></code> variants,
which take the battery’s chemistry/technology into account as an input variable.
A Li-ion dataset will have an input value of 0, while a Na-ion dataset will have
and input value of 1. This value is introduced into the network in the final
regression layers (just like <code class="docutils literal notranslate"><span class="pre">LSTM_v4</span></code> types introduce the ambient temperature
to them).</p>
<p>Because of this, datasets for this model must be created using this module’s
<a class="reference internal" href="#LSTM_chemistry.Torch_Dataset_LSTM" title="LSTM_chemistry.Torch_Dataset_LSTM"><code class="xref py py-class docutils literal notranslate"><span class="pre">Torch_Dataset_LSTM</span></code></a> class. However, it’s necessary to
mix batteries of different chemistries in the dataset for the model to be well
trained, which isn’t supported by it. The way to proceed is to create a
<a class="reference internal" href="#LSTM_chemistry.Torch_Dataset_LSTM" title="LSTM_chemistry.Torch_Dataset_LSTM"><code class="xref py py-class docutils literal notranslate"><span class="pre">Torch_Dataset_LSTM</span></code></a> class for each dataset (NASA, MIT,
Coin) and them merge them together through the
<a class="reference internal" href="#LSTM_chemistry.Torch_Dataset_Mixer" title="LSTM_chemistry.Torch_Dataset_Mixer"><code class="xref py py-class docutils literal notranslate"><span class="pre">Torch_Dataset_Mixer</span></code></a> class.</p>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>Notice that, because of this, each dataset may be normalised independently
(unless the user specifies the same <code class="docutils literal notranslate"><span class="pre">norm</span></code> for each dataset), and the final
<a class="reference internal" href="#LSTM_chemistry.Torch_Dataset_Mixer" title="LSTM_chemistry.Torch_Dataset_Mixer"><code class="xref py py-class docutils literal notranslate"><span class="pre">Torch_Dataset_Mixer</span></code></a> class <strong>won’t have a</strong> <code class="docutils literal notranslate"><span class="pre">norm</span></code>
<strong>attribute</strong> that you can call.</p>
<p>Because of this, when calling the <code class="xref py py-func docutils literal notranslate"><span class="pre">simulate()</span></code> with a loader
with this dataset, the user must specify <code class="docutils literal notranslate"><span class="pre">denormalize</span> <span class="pre">=</span> <span class="pre">False</span></code>. Function
<a class="reference internal" href="sphinx/Report.html#Load_Save.Load_Save" title="Load_Save.Load_Save"><code class="xref py py-func docutils literal notranslate"><span class="pre">Load_Save()</span></code></a> cannot be used because of this reason, but
<a class="reference internal" href="sphinx/Report.html#Load_Save.Load_Save_v2" title="Load_Save.Load_Save_v2"><code class="xref py py-func docutils literal notranslate"><span class="pre">Load_Save_v2()</span></code></a> can, including with
<code class="docutils literal notranslate"><span class="pre">denormalize_bool=True</span></code>, because it treat datasets separately.</p>
</div>
<p>Check the Google Colab/Notebook file “LSTM Chemistry Training.ipynb” for a
step-by-step of how to train a model.</p>
<div class="section" id="models">
<span id="lstm-chemistry-models"></span><h2>Models<a class="headerlink" href="#models" title="Permalink to this headline">¶</a></h2>
<dl class="py class">
<dt class="sig sig-object py" id="LSTM_chemistry.LSTM_v1">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">LSTM_chemistry.</span></span><span class="sig-name descname"><span class="pre">LSTM_v1</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">delta</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">hidden_dim</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">pooling_layer</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'bi_mean'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">drop_out</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">version</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lin_layers</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lin_dropout</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/LSTM_chemistry.html#LSTM_v1"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_chemistry.LSTM_v1" title="Permalink to this definition">¶</a></dt>
<dd><p>LSTM type neural net for Battery SOH estimation.</p>
<p>This model acts just like <a class="reference internal" href="LSTM.html#LSTM.LSTM_v1" title="LSTM.LSTM_v1"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v1</span></code></a>, but also takes the
dataset’s chemistry as an input in the regression layer (much like
<a class="reference internal" href="LSTM.html#LSTM.LSTM_v4" title="LSTM.LSTM_v4"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v4</span></code></a> takes the ambient temperature as input).</p>
<p>A Li-ion dataset will have an input of 0, whilst a Na-ion dataset will have
and input of 1.</p>
<p>For more information about the model’s architecture, check the documentation
for <a class="reference internal" href="LSTM.html#LSTM.LSTM_v1" title="LSTM.LSTM_v1"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v1</span></code></a>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>delta</strong> (<em>int</em>) – The size of the sliding window used to generate the x_i’s.</p></li>
<li><p><strong>hidden_dim</strong> (<em>int</em>) – Hidden dimension of the LSTM (also its main output dimension).</p></li>
<li><p><strong>pooling_layer</strong> (<em>{'last'</em><em>, </em><em>'mean'</em><em>, </em><em>'bi_mean&quot;}</em>) – Decides the type of pooling layer:
- ‘last’ (only take the last result),
- ‘mean’ (take the mean of the results) and
- ‘bi_mean’ (take the mean of the product).</p></li>
<li><p><strong>drop_out</strong> (<em>float</em>) – The probability of the dropout layer that comes right after the LSTM.
Must be a number between 0 and 1.</p></li>
<li><p><strong>norm</strong> (<em>tuple</em><em>(</em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>string</em><em>)</em><em>, </em><em>optional</em>) – <p>A tuple containing all of the information necessary for normalization.</p>
<p>This isn’t a necessary parameter and is not used in the model in any
way. It’s just useful for documentation purposes and for normalizing
test and validation sets.</p>
</p></li>
<li><p><strong>version</strong> (<em>int</em><em>, </em><em>default = 1</em>) – <p>The model version to be used.</p>
<ul>
<li><p><code class="docutils literal notranslate"><span class="pre">version</span></code> = 1 corresponds to the model created by the article cited.</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">version</span></code> = 2 corresponds to the same model, but adapted to also
take the charge cycle’s temperature data.</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">version</span></code> = 3 is similar to version 1, but takes the ambient
temperature as an extra inputs.</p></li>
</ul>
</p></li>
<li><p><strong>lin_layers</strong> (<em>int</em><em>, </em><em>default = 1</em>) – The number of linear regression layers. As of now, cannot be greater
than two.</p></li>
<li><p><strong>lin_dropout</strong> (<em>float</em><em>, </em><em>optional</em>) – The value for the dropout layer that comes after the first linear layer
in the regression step. Will only be added if <code class="docutils literal notranslate"><span class="pre">lin_layers</span></code> &gt; 1.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><strong>AssertionError</strong> – If the version in different than 1, 2 or 3.
    If an unsupported pooling_layer is informed.</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">torch.utils.data</span> <span class="kn">import</span> <span class="n">Dataset</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="o">*</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">delta</span> <span class="o">=</span> <span class="mi">10</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">hidden_dim</span> <span class="o">=</span> <span class="mi">20</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">version</span> <span class="o">=</span> <span class="mi">2</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">model</span> <span class="o">=</span> <span class="n">LSTM_v1</span><span class="p">(</span><span class="n">delta</span><span class="p">,</span> <span class="n">hidden_dim</span><span class="p">,</span> <span class="n">pooling_layer</span><span class="o">=</span><span class="s1">&#39;last&#39;</span><span class="p">,</span> <span class="n">version</span><span class="o">=</span><span class="n">version</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">([</span><span class="n">Battery</span><span class="p">],</span> <span class="n">delta</span><span class="p">,</span> <span class="n">version</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">estimated_capacity</span> <span class="o">=</span> <span class="n">model</span><span class="p">(</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">inputs</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">loss_function</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">nn</span><span class="o">.</span><span class="n">MSELoss</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">loss</span> <span class="o">=</span> <span class="n">loss_function</span><span class="p">(</span><span class="n">estimated_capacity</span><span class="p">,</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">output</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
<span class="go">2.2862</span>
</pre></div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="LSTM_chemistry.LSTM_v1.forward">
<span class="sig-name descname"><span class="pre">forward</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">inputs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/LSTM_chemistry.html#LSTM_v1.forward"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_chemistry.LSTM_v1.forward" title="Permalink to this definition">¶</a></dt>
<dd><p>Defines the computation performed at every call.</p>
<p>Should be overridden by all subclasses.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Although the recipe for forward pass needs to be defined within
this function, one should call the <code class="xref py py-class docutils literal notranslate"><span class="pre">Module</span></code> instance afterwards
instead of this since the former takes care of running the
registered hooks while the latter silently ignores them.</p>
</div>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="LSTM_chemistry.LSTM_v4">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">LSTM_chemistry.</span></span><span class="sig-name descname"><span class="pre">LSTM_v4</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">delta</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">hidden_dim</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">pooling_layer</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'bi_mean'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">drop_out</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">version</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">4</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lin_layers</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lin_dropout</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/LSTM_chemistry.html#LSTM_v4"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_chemistry.LSTM_v4" title="Permalink to this definition">¶</a></dt>
<dd><blockquote>
<div><p>LSTM type neural net for Battery SOH estimation.</p>
</div></blockquote>
<p>This model acts just like <a class="reference internal" href="LSTM.html#LSTM.LSTM_v4" title="LSTM.LSTM_v4"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v4</span></code></a>, but also takes the
dataset’s chemistry as an input in the regression layer.</p>
<p>A Li-ion dataset will have an input of 0, whilst a Na-ion dataset will have
and input of 1.</p>
<p>For more information about the model’s architecture, check the documentation
for <a class="reference internal" href="LSTM.html#LSTM.LSTM_v4" title="LSTM.LSTM_v4"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v4</span></code></a>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>delta</strong> (<em>int</em>) – The size of the sliding window used to generate the x_i’s.</p></li>
<li><p><strong>hidden_dim</strong> (<em>int</em>) – Hidden dimension of the LSTM (also its main output dimension).</p></li>
<li><p><strong>pooling_layer</strong> (<em>{'last'</em><em>, </em><em>'mean'</em><em>, </em><em>'bi_mean&quot;}</em>) – Decides the type of pooling layer:
- ‘last’ (only take the last result),
- ‘mean’ (take the mean of the results) and
- ‘bi_mean’ (take the mean of the product).</p></li>
<li><p><strong>drop_out</strong> (<em>float</em>) – The probability of the dropout layer that comes right after the LSTM.
Must be a number between 0 and 1.</p></li>
<li><p><strong>norm</strong> (<em>tuple</em><em>(</em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>string</em><em>)</em><em>, </em><em>optional</em>) – <p>A tuple containing all of the information necessary for normalization.</p>
<p>This isn’t a necessary parameter and is not used in the model in any
way. It’s just useful for documentation purposes and for normalizing
test and validation sets.</p>
</p></li>
<li><p><strong>version</strong> (<em>int</em><em>, </em><em>default = 4</em>) – This is a new version being tested It will take the ambient temperature
as an input directly into the linear layers.
<code class="docutils literal notranslate"><span class="pre">version</span></code> = 4 corresponds to <code class="docutils literal notranslate"><span class="pre">LSTM_v1``s</span> <span class="pre">version</span> <span class="pre">1,</span> <span class="pre">and</span>
<span class="pre">``version</span></code> = 5 corresponds to <a href="#id1"><span class="problematic" id="id2">``</span></a>LSTM_v1``s version 2.</p></li>
<li><p><strong>lin_layers</strong> (<em>int</em><em>, </em><em>default = 1</em>) – The number of linear regression layers. As of now, cannot be greater
than two.</p></li>
<li><p><strong>lin_dropout</strong> (<em>float</em><em>, </em><em>optional</em>) – The value for the dropout layer that comes after the first linear layer
in the regression step. Will only be added if <code class="docutils literal notranslate"><span class="pre">lin_layers</span> <span class="pre">&gt;</span> <span class="pre">1</span></code>.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><strong>AssertionError</strong> – If the version in different than 4 or 5.
    If an unsupported pooling_layer is informed.</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">torch.utils.data</span> <span class="kn">import</span> <span class="n">Dataset</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="o">*</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">delta</span> <span class="o">=</span> <span class="mi">10</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">hidden_dim</span> <span class="o">=</span> <span class="mi">20</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">version</span> <span class="o">=</span> <span class="mi">4</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">model</span> <span class="o">=</span> <span class="n">LSTM_v4</span><span class="p">(</span><span class="n">delta</span><span class="p">,</span> <span class="n">hidden_dim</span><span class="p">,</span> <span class="n">pooling_layer</span><span class="o">=</span><span class="s1">&#39;last&#39;</span><span class="p">,</span> <span class="n">version</span><span class="o">=</span><span class="n">version</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">([</span><span class="n">Battery</span><span class="p">],</span> <span class="n">delta</span><span class="p">,</span> <span class="n">version</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">estimated_capacity</span> <span class="o">=</span> <span class="n">model</span><span class="p">(</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">inputs</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">loss_function</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">nn</span><span class="o">.</span><span class="n">MSELoss</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">loss</span> <span class="o">=</span> <span class="n">loss_function</span><span class="p">(</span><span class="n">estimated_capacity</span><span class="p">,</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">output</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
<span class="go">2.2862</span>
</pre></div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="LSTM_chemistry.LSTM_v4.forward">
<span class="sig-name descname"><span class="pre">forward</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">inputs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/LSTM_chemistry.html#LSTM_v4.forward"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_chemistry.LSTM_v4.forward" title="Permalink to this definition">¶</a></dt>
<dd><p>Defines the computation performed at every call.</p>
<p>Should be overridden by all subclasses.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Although the recipe for forward pass needs to be defined within
this function, one should call the <code class="xref py py-class docutils literal notranslate"><span class="pre">Module</span></code> instance afterwards
instead of this since the former takes care of running the
registered hooks while the latter silently ignores them.</p>
</div>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="dataset-classes">
<span id="lstm-chemistry-dataset"></span><h2>Dataset Classes<a class="headerlink" href="#dataset-classes" title="Permalink to this headline">¶</a></h2>
<dl class="py class">
<dt class="sig sig-object py" id="LSTM_chemistry.Torch_Dataset_LSTM">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">LSTM_chemistry.</span></span><span class="sig-name descname"><span class="pre">Torch_Dataset_LSTM</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Battery_list</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">delta</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">model_version</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">print_bool</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">time_step</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">threshold</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0.1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">min_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">10</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fixed_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">150</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm_type</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'zscore'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">adimensionalize</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cycle_lim</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1000000.0</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/LSTM_chemistry.html#Torch_Dataset_LSTM"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_chemistry.Torch_Dataset_LSTM" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a pytorch Dataset class that can readily be loaded with torch’s
Loader class for training and validation.</p>
<p>This class is just like <a class="reference internal" href="#LSTM_chemistry.Torch_Dataset_LSTM" title="LSTM_chemistry.Torch_Dataset_LSTM"><code class="xref py py-class docutils literal notranslate"><span class="pre">Torch_Dataset_LSTM</span></code></a> except that it adds the
battery’s chemistry to the inputs - a value indicating if the battery is
either of type Li-ion (0) or Na-ion (1). Check the other module’s
documentation for more information.</p>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>This class by itself is not capable of treating two dataset types in one
go. Rather, it should be used for each dataset separately, and the
datasets should then be mixed using <a class="reference internal" href="#LSTM_chemistry.Torch_Dataset_Mixer" title="LSTM_chemistry.Torch_Dataset_Mixer"><code class="xref py py-class docutils literal notranslate"><span class="pre">Torch_Dataset_Mixer</span></code></a></p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Battery_list</strong> (<em>list</em><em>[</em><a class="reference internal" href="sphinx/NASA.html#Nasa_Classes.Clean_Battery" title="Nasa_Classes.Clean_Battery"><em>Clean_Battery</em></a><em>]</em>) – List with the Batteries that we want to use for creating the dataset.</p></li>
<li><p><strong>delta</strong> (<em>int</em>) – The size of the sliding window used to generate the x_i’s.</p></li>
<li><p><strong>model_version</strong> (<em>{1</em><em>, </em><em>2</em><em>, </em><em>3</em><em>, </em><em>4</em><em>, </em><em>5}</em>) – An integer indicating which LSTM version to use.
if <code class="docutils literal notranslate"><span class="pre">version</span></code> == 1: then only I and V data will be used.
elif <code class="docutils literal notranslate"><span class="pre">version</span></code> == 2: then I, V and T will be taken into account.
elif <code class="docutils literal notranslate"><span class="pre">version</span></code> == 3: then I, V and amb_T will be taken into account.
elif <code class="docutils literal notranslate"><span class="pre">version</span></code> == 4: then I, V and amb_T will be taken into account,
but amb_T will enter directly in the last step, the NN.
elif <code class="docutils literal notranslate"><span class="pre">version</span></code> == 5: then I, V, T and amb_T will be taken into account,
mixing models 2 and 4. Redundant.</p></li>
<li><p><strong>print_bool</strong> (<em>bool</em><em>, </em><em>default = False</em>) – Whether or not to print some information while the code runs.
Namely, if we want to print the battery’s name and the number of points.</p></li>
<li><p><strong>time_step</strong> (<em>int</em><em>, </em><em>optional</em>) – The desired time step for the resampling procedure.
If <code class="docutils literal notranslate"><span class="pre">None</span></code> is given, than a time step will be automatically generated
by the method <code class="docutils literal notranslate"><span class="pre">time_step_function</span></code>.</p></li>
<li><p><strong>threshold</strong> (<em>float</em><em>, </em><em>default = 0.1</em>) – The minimum capacity value to be considered as relevant [A.h].</p></li>
<li><p><strong>min_len</strong> (<em>int</em><em>, </em><em>default = 10</em>) – The minimum amount of points a charge cycle must have to be considered
as relevant.</p></li>
<li><p><strong>fixed_len</strong> (<em>int</em><em>, </em><em>optional</em>) – if different than <code class="docutils literal notranslate"><span class="pre">None</span></code> (default value), then the charge and discharge
curves will be limited to <code class="docutils literal notranslate"><span class="pre">fixed_len</span></code> points. This will override
<code class="docutils literal notranslate"><span class="pre">min_len</span></code>.</p></li>
<li><p><strong>norm_type</strong> (<em>{'zscore'</em><em>, </em><em>'minmax'}</em>) – A string indicating which kind of normalization to do.</p></li>
<li><p><strong>norm</strong> (<em>tuple</em><em>(</em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>string</em><em>)</em><em>, </em><em>optional</em>) – A tuple containing all of the information necessary for normalization.
In entered as input, <code class="docutils literal notranslate"><span class="pre">norm_type</span></code> will be overridden by norm[4] and the
given information will be used for the normalization</p></li>
<li><p><strong>adimensionalize</strong> (<em>bool</em><em>, </em><em>default = True</em>) – <p>Whether or not to make variables dimensionless before adding them to the
inputs and output lists.</p>
<ul>
<li><p>The Capacity (output) is normalized by the nominal capacity
(<code class="docutils literal notranslate"><span class="pre">Q_nominal</span></code>);</p></li>
<li><p>The Current is normalized by the C rate (<code class="docutils literal notranslate"><span class="pre">C_rate</span></code>) -
which is the current necessary for charging the battery in one hour
(theoretically);</p></li>
<li><p>The Voltage is normalized by the nominal voltage (<code class="docutils literal notranslate"><span class="pre">V_nominal</span></code>),
the voltage at the plateau in the CV part of the charge curve.</p></li>
</ul>
<p>The values of these parameters are defined inside of each battery class.</p>
</p></li>
<li><p><strong>cycle_lim</strong> (<em>int</em><em>, </em><em>optional</em>) – The greatest cycle number to take into account for the dataset creation.
Default equals <code class="docutils literal notranslate"><span class="pre">1e6</span></code> meaning that no cycles will be ignored.</p></li>
</ul>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM_chemistry.Torch_Dataset_LSTM.dataset_name">
<span class="sig-name descname"><span class="pre">dataset_name</span></span><a class="headerlink" href="#LSTM_chemistry.Torch_Dataset_LSTM.dataset_name" title="Permalink to this definition">¶</a></dt>
<dd><p>The name of the dataset (‘Dataset_Nasa’, for instance).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>str</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM_chemistry.Torch_Dataset_LSTM.batteries">
<span class="sig-name descname"><span class="pre">batteries</span></span><a class="headerlink" href="#LSTM_chemistry.Torch_Dataset_LSTM.batteries" title="Permalink to this definition">¶</a></dt>
<dd><p>A list with the file name of each battery used.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[str]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM_chemistry.Torch_Dataset_LSTM.dataset_format">
<span class="sig-name descname"><span class="pre">dataset_format</span></span><a class="headerlink" href="#LSTM_chemistry.Torch_Dataset_LSTM.dataset_format" title="Permalink to this definition">¶</a></dt>
<dd><p>A string indicating the type of data format used: ‘You et al. [56]’.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>str</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM_chemistry.Torch_Dataset_LSTM.inputs">
<span class="sig-name descname"><span class="pre">inputs</span></span><a class="headerlink" href="#LSTM_chemistry.Torch_Dataset_LSTM.inputs" title="Permalink to this definition">¶</a></dt>
<dd><p>A list with the input tensors for each cycle.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[Tensors]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM_chemistry.Torch_Dataset_LSTM.output">
<span class="sig-name descname"><span class="pre">output</span></span><a class="headerlink" href="#LSTM_chemistry.Torch_Dataset_LSTM.output" title="Permalink to this definition">¶</a></dt>
<dd><p>A tensor with the output capacity tensors for each cycle.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>Tensor</p>
</dd>
</dl>
</dd></dl>

<dl class="field-list simple">
<dt class="field-odd">Raises</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>AssertionError</strong> – If the specified value of <code class="docutils literal notranslate"><span class="pre">delta</span></code> is &lt; 1.
    If no batteries are given.
    If the specified version is invalid.
    If <code class="docutils literal notranslate"><span class="pre">model_version</span></code> is 2 or 5 and <code class="docutils literal notranslate"><span class="pre">self.dataset_name</span></code> is
    <code class="docutils literal notranslate"><span class="pre">Clean_Coin_Battery</span></code>.</p></li>
<li><p><strong>ValueError</strong> – If the model_version is unknown.</p></li>
</ul>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">torch.utils.data</span> <span class="kn">import</span> <span class="n">Dataset</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="n">Torch_Dataset_LSTM</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">delta</span> <span class="o">=</span> <span class="mi">10</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">version</span> <span class="o">=</span> <span class="mi">2</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">([</span><span class="n">Battery</span><span class="p">],</span> <span class="n">delta</span><span class="p">,</span> <span class="n">version</span><span class="p">,</span>
<span class="gp">... </span>                                   <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="go">B0005</span>
<span class="go">165</span>
</pre></div>
</div>
</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="LSTM_chemistry.Torch_Dataset_Mixer">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">LSTM_chemistry.</span></span><span class="sig-name descname"><span class="pre">Torch_Dataset_Mixer</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">dataset_list</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">renorm</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/LSTM_chemistry.html#Torch_Dataset_Mixer"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_chemistry.Torch_Dataset_Mixer" title="Permalink to this definition">¶</a></dt>
<dd><p>Class for mixing different dataset types.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Notice that the inputs and outputs are normalised prior to this class’s
initialization, and that each dataset that is being mixed will have
different normalisation parameters. In this sense, this class cannot
have a <code class="docutils literal notranslate"><span class="pre">norm</span></code> attribute and thus attempts to denormalize outputs
directly from this class will fail. Because of this, when simulating
results with <a class="reference internal" href="sphinx/Training.html#Training.simulate" title="Training.simulate"><code class="xref py py-obj docutils literal notranslate"><span class="pre">Training.simulate</span></code></a>, make sure you call it with
<code class="docutils literal notranslate"><span class="pre">denormalize=False</span></code> so that no <code class="docutils literal notranslate"><span class="pre">AttributeError</span></code> is raised.</p>
</div>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>Tests weren’t very successful so development has been halted. Missing
functionalities and attributes may cause <a href="#id3"><span class="problematic" id="id4">``</span></a>AttributeError``s in other
functions.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>dataset_list</strong> (<em>list</em><em>[</em><a class="reference internal" href="#LSTM_chemistry.Torch_Dataset_LSTM" title="LSTM_chemistry.Torch_Dataset_LSTM"><em>Torch_Dataset_LSTM</em></a><em>]</em>) – A list of the different datasets to be used.</p></li>
<li><p><strong>renorm</strong> (<em>bool</em><em>, </em><em>optional</em>) – Whether or not to renormalize all the data with respect to the whole
set. Experimental, didn’t yield good results.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="LSTM_chemistry.norm_adapt">
<span class="sig-prename descclassname"><span class="pre">LSTM_chemistry.</span></span><span class="sig-name descname"><span class="pre">norm_adapt</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">norm</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">tech</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/LSTM_chemistry.html#norm_adapt"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_chemistry.norm_adapt" title="Permalink to this definition">¶</a></dt>
<dd><p>Function for adapting a given <code class="docutils literal notranslate"><span class="pre">norm</span></code> tuple for LSTM_chemistry dataset.</p>
<p>This function basically adds an entry to the normalisation parameters
corresponding to the battery’s chemistry. It’s useful for when user wants to
use a <code class="docutils literal notranslate"><span class="pre">norm</span></code> calculated for other variants for this one.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>norm</strong> (<em>tuple</em>) – A norm tuple.</p></li>
<li><p><strong>tech</strong> (<em>{0</em><em>, </em><em>1}</em><em>, </em><em>default = 0</em>) – An <code class="docutils literal notranslate"><span class="pre">int</span></code> indicating which battery chemistry is used (0 is Li-ion and
1 is Na-ion).</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>A norm tuple as normal.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>tuple</p>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><strong>AssertionError</strong> – If the <code class="docutils literal notranslate"><span class="pre">tech</span></code> is different than 0 or 1.</p>
</dd>
</dl>
</dd></dl>

</div>
</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2022, Antonio ROCHA AZEVEDO.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>